import torch
from sklearn.decomposition import PCA
from tqdm import tqdm
import poisoned_datasets
import os
import cox
from cox.utils import Parameters
from robustness import defaults, train, model_utils
from argparse import ArgumentParser
from torchvision.datasets import CIFAR10
from robustness.datasets import DATASETS
import torch.nn as nn
import torch.nn.functional as F
import numpy as np


ds = poisoned_datasets.CIFAR(os.path.join(os.environ['SHARDATA'], 'datasets/cifar'))
selection_func = lambda x: [False for _ in x]

train_loader, test_loader = ds.make_loaders(shuffle=True, batch_size=128, selection_func=selection_func)

from robustness import data_augmentation as da
train_set = CIFAR10(
    root='/storage/anon/datasets/cifar', 
    train=True,
    transform=da.TEST_TRANSFORMS_DEFAULT(32)
)

train_loader = torch.utils.data.DataLoader(train_set, batch_size=128, shuffle=False)

model, checkpoint_loaded = model_utils.make_and_restore_model(
    arch='resnet18',
    dataset=ds,
    resume_path='/storage/anon/cifar/clean/84ee88cb-7daa-40f0-8d58-2d91900bc63f/checkpoint.pt.latest'
)

c = list(model.children())
c = c[1]
c = list(c.children())
fe = torch.nn.Sequential(*c[: 4])

outputs = []
for x, _ in tqdm(train_loader):
    output = fe(x.cuda()).detach().cpu().numpy()
    output = output.reshape((output.shape[0], -1))
    outputs.extend(output)

pca = PCA(512)

